Scala Reflection Library2.13.0 < Back


# Packages

-  package root
  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package macros

  EXPERIMENTAL

  EXPERIMENTAL

  The base package for Scala macros.

  Macros are functions that are called by the compiler during compilation. Within these functions the programmer has access to compiler APIs. For example, it is possible to generate, analyze and typecheck code.

  See the Macros Guide on how to get started with Scala macros.

  Definition Classes
    reflect
-  package whitebox
  Definition Classes
    macros
-  trait Context extends blackbox.Context

  EXPERIMENTAL

  EXPERIMENTAL

  The whitebox Scala macros context.

  See the overview page for a description of how macros work. This documentation entry provides information on the API available to macro writers.

  A macro context wraps a compiler universe exposed in `universe` and having type scala.reflect.macros.Universe. This type is a refinement over the generic reflection API provided in scala.reflect.api.Universe. The extended Universe provides mutability for reflection artifacts (e.g. macros can change types of compiler trees, add annotation to symbols representing definitions, etc) and exposes some internal compiler functionality such as `Symbol.deSkolemize` or `Tree.attachments`.

  Another fundamental part of a macro context is `macroApplication`, which provides access to the tree undergoing macro expansion. Parts of this tree can be found in arguments of the corresponding macro implementations and in `prefix`, but `macroApplication` gives the full picture.

  Other than that, macro contexts provide facilities for typechecking, exploring the compiler's symbol table and enclosing trees and compilation units, evaluating trees, logging warnings/errors and much more. Refer to the documentation of top-level traits in this package to learn the details.

  If a macro def refers to a macro impl that uses `whitebox.Context`, then this macro def becomes a whitebox macro, gaining the ability to refine the type of its expansion beyond its official return type, which enables a number of important use cases. Blackbox macros, i.e. the ones defined with `blackbox.Context`, can't do that, so they are less powerful. However blackbox macros are also going to enjoy better support than whitebox macros, so choose wisely. See the Macros Guide for more information.

  Definition Classes
    whitebox
  See also

    `scala.reflect.macros.blackbox.Context`

- ContextInternalApi
- EnclosureException
- ImplicitCandidate
- PrefixType
- TypecheckMode

c

scala.reflect.macros.whitebox.Context

# ImplicitCandidate

###

#### case class ImplicitCandidate(pre: Context.Type, sym: Context.Symbol, pt: Context.Type, tree: Context.Tree) extends Product with Serializable

Information about one of the currently considered implicit candidates. Candidates are used in plural form, because implicit parameters may themselves have implicit parameters, hence implicit searches can recursively trigger other implicit searches.

`pre` and `sym` provide information about the candidate itself. `pt` and `tree` store the parameters of the implicit search the candidate is participating in.

Source
  Context.scala

Linear Supertypes
java.io.Serializable, Product, Equals, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ImplicitCandidate
2. Serializable
3. Product
4. Equals
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new ImplicitCandidate(pre: Context.Type, sym: Context.Symbol, pt: Context.Type, tree: Context.Tree)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ImplicitCandidate toany2stringadd[ImplicitCandidate] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ImplicitCandidate, B)
   Implicit
     This member is added by an implicit conversion from ImplicitCandidate toArrowAssoc[ImplicitCandidate] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def ensuring(cond: (ImplicitCandidate) => Boolean, msg: => Any): ImplicitCandidate
   Implicit
     This member is added by an implicit conversion from ImplicitCandidate toEnsuring[ImplicitCandidate] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (ImplicitCandidate) => Boolean): ImplicitCandidate
   Implicit
     This member is added by an implicit conversion from ImplicitCandidate toEnsuring[ImplicitCandidate] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: => Any): ImplicitCandidate
    Implicit
      This member is added by an implicit conversion from ImplicitCandidate toEnsuring[ImplicitCandidate] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): ImplicitCandidate
    Implicit
      This member is added by an implicit conversion from ImplicitCandidate toEnsuring[ImplicitCandidate] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
14.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ImplicitCandidate toStringFormat[ImplicitCandidate] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
15.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
16.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
17.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
18.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
19.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
20.  val pre: Context.Type
21.  def productElementNames: Iterator[String]
    Definition Classes
      Product
22.  val pt: Context.Type
23.  val sym: Context.Symbol
24.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
25.  val tree: Context.Tree
26.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
27.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
28.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (ImplicitCandidate, B)
   Implicit
     This member is added by an implicit conversion from ImplicitCandidate toArrowAssoc[ImplicitCandidate] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromImplicitCandidate to any2stringadd[ImplicitCandidate]

### Inherited by implicit conversion StringFormat fromImplicitCandidate to StringFormat[ImplicitCandidate]

### Inherited by implicit conversion Ensuring fromImplicitCandidate to Ensuring[ImplicitCandidate]

### Inherited by implicit conversion ArrowAssoc fromImplicitCandidate to ArrowAssoc[ImplicitCandidate]

### Ungrouped